package com.bocloud.cos.booter.config;

import com.gitee.starblues.core.classloader.MainResourcePatternDefiner;
import org.springframework.stereotype.Component;

import java.util.HashSet;
import java.util.Set;

/**
 * 配置从主程序加载Class, 在主程序中全局扩展
 *
 * @author zhangyf
 * @since 2022-06-09
 */
@Component
public class CosMainResourcePatternDefiner implements MainResourcePatternDefiner {
    @Override
    public Set<String> getIncludePatterns() {
        // 包含包匹配
        Set<String> includePatterns = new HashSet<>();
        includePatterns.add("org/springframework/util/**");
        includePatterns.add("org/springframework/core/**");
        includePatterns.add("org/springframework/boot/**");
        includePatterns.add("org/springframework/beans/**");
        includePatterns.add("org/springframework/context/**");
        includePatterns.add("org/springframework/cglib/**");
        includePatterns.add("org/springframework/stereotype/**");
        includePatterns.add("org/springframework/jdbc/**");
        includePatterns.add("org/springframework/cloud/**");
        includePatterns.add("org/springframework/amqp/**");
        includePatterns.add("org/springframework/scheduling/**");
        includePatterns.add("org/springframework/mail/**");
        includePatterns.add("com/github/xiaoymin/**");
        includePatterns.add("org/apache/curator/**");
        includePatterns.add("org/apache/commons/**");
        includePatterns.add("com/megatron/**");
        includePatterns.add("org/slf4j/**");
        includePatterns.add("com/alibaba/fastjson/**");
        includePatterns.add("com/bocloud/cmp/boot/**");
        includePatterns.add("com/google/common/**");
        return includePatterns;
    }

    @Override
    public Set<String> getExcludePatterns() {
        return null;
    }
}
