package com.bocloud.cos.booter.scheduler;

import com.bocloud.cos.intf.CloudBillService;
import com.bocloud.cos.utils.DateUtil;
import com.megatron.framework.core.CurrentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;

@Component
public class PublicCloudBillingScheduler {

    @Autowired
    private CurrentService service;
    @Autowired
    private CloudBillService cloudBillService;

    @Scheduled(cron = "${public.cloud.bill.schedule:0 0 2 * * ?}")
    protected void sync() throws Exception {
        if (service.isLeader()) {
            cloudBillService.synchronizeData(null, DateUtil.localYearMonthFormat(LocalDateTime.now()));
        }
    }
}