package com.bocloud.cos.entity;

import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreUpdate;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 云平台账号配置实体类
 *
 * @author lym
 * @since 2022-06-16
 */
@Table("cloud_vendor_account")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class CloudVendorAccount extends Generic {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * UUID
     */
    @Column("uuid")
    private String uuid;
    /**
     * 平台名称
     */
    @Column("vendor_name")
    private String vendorName;
    /**
     * 平台类型
     */
    @Column("vendor_type")
    private String vendorType;
    /**
     * 平台认证信息
     */
    @Column("authentication")
    private String authentication;
    /**
     * 描述信息
     */
    @Column("remark")
    private String remark;
    /**
     * 描述信息
     */
    @Column("status")
    private String status;
    /**
     * 是否删除（0：否；1：是）
     */
    @Column("is_deleted")
    private Boolean deleted;
    /**
     * 创建时间
     */
    @IgnoreUpdate
    @Column(value = "gmt_create", nullable = false)
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    /**
     * 修改时间
     */
    @Column("gmt_modify")
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;
    /**
     * 创建人ID
     */
    @IgnoreUpdate
    @Column("creator_id")
    private Long creatorId;
    /**
     * 修改人ID
     */
    @Column("mender_id")
    private Long menderId;
}
