package com.bocloud.cos.entity;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.*;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 商品SKU
 *
 * @author Administrator
 */
@Table("service_address_vendor")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
public class ServiceAddressVendor extends Generic {

    @PK(value = PKStrategy.AUTO)
    private Long id;

    /**
     * 服务商id
     */
    @Column
    private Long addressId;
    /**
     * 云平台id
     */
    @Column
    private Long vendorId;
    /**
     * 创建人
     */
    @Column
    private Long creatorId;
    /**
     * 创建时间
     */
    @IgnoreUpdate
    @Column(
            value = "gmt_create",
            nullable = false
    )
    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date gmtCreate;
}
