package com.bocloud.cos.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

/**
 * 商品SKU
 *
 * @author Administrator
 */
@Table("service_sku")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
public class ServiceSku extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 商品编码
     */
    @Column("sn")
    private String sn;
    /**
     * 服务ID
     */
    @Column("service_id")
    private Long serviceId;
    /**
     * 服务编码
     */
    @Column("service_code")
    private String serviceCode;
    /**
     * 产品编码
     */
    @Column("code")
    private String code;
    /**
     * 类型ID
     */
    @Column("category_id")
    private Long categoryId;
    /**
     * 规格
     */
    @Column("spec")
    private String spec;
    /**
     * 是否内置
     */
    @Column("is_reserved")
    @Deprecated
    private Boolean reserved;


    /**
     * 每小时价格
     */
    @Column("hour_price")
    private BigDecimal hourPrice;
    /**
     * 每月价格
     */
    @Column("month_price")
    private BigDecimal monthPrice;

    /**
     * 每年价格
     */
    @Column("year_price")
    private BigDecimal yearPrice;

    /**
     * 自定义折扣
     */
    private BigDecimal discount;

    /**
     * 资费代码
     */
    @Column("tariff_code")
    private String tariffCode;
    @IgnoreAll
    private String serviceName;
    @IgnoreAll
    private String categoryName;
    @IgnoreAll
    private Long resourceId;
    @IgnoreAll
    private String categoryProps;
    @IgnoreAll
    private CloudService.BillPolicy billPolicy;
    @IgnoreAll
    private Boolean billable;
    @IgnoreAll
    private String basicPrice;
    @Column("catalog_id")
    private Long catalogId;
    @IgnoreAll
    private String catalogName;


    public enum Status {
        /**
         * 启用
         */
        enable,
        /**
         * 禁用
         */
        disable,

    }
}
