package com.bocloud.cos.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreUpdate;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 问题工单实体类
 *
 * @author wangyu
 * @version 1.0
 * @since 2019年5月8日
 */
@Data
@Table("work_order")
public class WorkOrder extends GenericEntity {

    // ID
    @PK(PKStrategy.AUTO)
    private Long id;
    // 问题类别
    @Column("catalog")
    private String catalog;
    // 手机号码
    @Column("phone")
    private String phone;
    // 联系邮箱
    @Column("email")
    private String email;
    // 问题填报时间
    @Column("report_time")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date reportTime;
    // 租户ID
    @Column("tenant_id")
    private Long tenantId;
    // 故障内容
    @Column("content")
    private String content;
    // 服务星级
    @Column("star")
    private Integer star;
    // 子订单号
    @Column("order_item_sn")
    private String orderItemSn;
    // 资源ID
    @Column("instance_uuid")
    private String instanceUuid;
    // 资源类别
    @Column("resource_catalog")
    private String resourceCatalog;
    // 资源类型
    @Column("resource_category")
    private String resourceCategory;

}
