package com.bocloud.cos.entity.assess;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.*;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 考核分类实体类
 *
 * @author lym
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("assess_classify")
public class AssessClassify extends Generic {
    /**
     * id
     */
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 分类名称
     */
    @Column("name")
    private String name;
    /**
     * 分类编码
     */
    @Column("code")
    private String code;
    /**
     * 考核群体
     */
    @Column("colony")
    private String colony;
    /**
     * 分类编码
     */
    @Column("remark")
    private String remark;
    /**
     * 创建人ID
     */
    @Column("creator_id")
    private Long creatorId;
    /**
     * 创建时间
     */
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column("gmt_create")
    private Date gmtCreate;
    /**
     * 修改时间
     */
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column("gmt_modify")
    private Date gmtModify;
    /**
     * 修改人ID
     */
    @Column("mender_id")
    private Long menderId;
    /**
     * 标识是否禁止删除（true：是；false：否）
     */
    @Column("delete_disable")
    private Boolean deleteDisable;

    /**
     * 创建人
     */
    @IgnoreAll
    private String creator;
}
