package com.bocloud.cos.entity.assess;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 考核采集指标明细
 *
 * @author lym
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("assess_collection_metric_detail")
public class AssessCollectionMetricDetail extends Generic {
    /**
     * id
     */
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 表达式
     */
    @Column("expression")
    private String expression;
    /**
     * 资源类型
     */
    @Column("resource_type")
    private String resourceType;
    /**
     * 资源名称
     */
    @Column("resource_name")
    private String resourceName;
    /**
     * 考核指标ID
     */
    @Column("collection_metric_id")
    private Long collectionMetricId;
    /**
     * 监控指标名称
     */
    @Column("monitor_metric_name")
    private String monitorMetricName;
}
