package com.bocloud.cos.enums;

import lombok.Getter;
import lombok.Setter;

/**
 * 考核采集方式
 *
 * @author lym
 */
@Getter
public enum AssessAcquisitionModeEnum {

    // 规则评判方式
    MANUAL("人工手动", "MANUAL"), AUTO("自动采集", "AUTO");

    @Setter
    private final String name;

    @Setter
    private final String code;

    AssessAcquisitionModeEnum(String name, String code) {
        this.name = name;
        this.code = code;
    }

    public static String getName(String code) {
        for (AssessAcquisitionModeEnum c : AssessAcquisitionModeEnum.values()) {
            if (c.getCode().equals(code)) {
                return c.name;
            }
        }
        return null;
    }
}
