package com.bocloud.cos.model;

import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class PublicCloudBillModel {
    private String businessCodeName;
    private String productName;
    private String payModeName;
    private String regionName;
    private String zoneName;
    private String resourceId;
    private String regionId;
    private String resourceName;
    private String actionTypeName;
    private String orderSn;
    private String payTime;
    private Date feeBeginTime;
    private Date feeEndTime;
    private String configDesc;
    private BigDecimal totalCost;
    private String reduceType;
    private BigDecimal money;
    private String status;
    private String productDetail;
    private String productCode;
    private String subscriptionType;
    private BigDecimal deductedByCashCoupons;
    private BigDecimal deductedByCoupons;
    private BigDecimal deductedByPrepaidCard;
    private BigDecimal invoiceDiscount;
    private BigDecimal outstandingAmount;
    private BigDecimal pretaxAmount;
    private BigDecimal pretaxGrossAmount;
    private BigDecimal roundDownDiscount;
    private String subscriptionId;
    private String subscriptionName;
    private String resourceGroupName;
    private BigDecimal quantity;
    private String orderSnName;
    private BigDecimal unitPrice;
    private String billingCurrency;
    private String consumedService;
    private String meterId;
    private Date useResourceData;
    private String month;
    private String productLine;
    private String recordType;
    private PublicCloudBillModel.MeterDetailsModel meterDetailsModel;

    public PublicCloudBillModel() {
    }

    @Override
    public boolean equals(Object o) {
        if (o == this) {
            return true;
        } else if (!(o instanceof PublicCloudBillModel)) {
            return false;
        } else {
            PublicCloudBillModel other = (PublicCloudBillModel)o;
            if (!other.canEqual(this)) {
                return false;
            } else {
                Object this$businessCodeName = this.getBusinessCodeName();
                Object other$businessCodeName = other.getBusinessCodeName();
                if (this$businessCodeName == null) {
                    if (other$businessCodeName != null) {
                        return false;
                    }
                } else if (!this$businessCodeName.equals(other$businessCodeName)) {
                    return false;
                }

                Object this$productName = this.getProductName();
                Object other$productName = other.getProductName();
                if (this$productName == null) {
                    if (other$productName != null) {
                        return false;
                    }
                } else if (!this$productName.equals(other$productName)) {
                    return false;
                }

                Object this$payModeName = this.getPayModeName();
                Object other$payModeName = other.getPayModeName();
                if (this$payModeName == null) {
                    if (other$payModeName != null) {
                        return false;
                    }
                } else if (!this$payModeName.equals(other$payModeName)) {
                    return false;
                }

                label494: {
                    Object this$regionName = this.getRegionName();
                    Object other$regionName = other.getRegionName();
                    if (this$regionName == null) {
                        if (other$regionName == null) {
                            break label494;
                        }
                    } else if (this$regionName.equals(other$regionName)) {
                        break label494;
                    }

                    return false;
                }

                label487: {
                    Object this$zoneName = this.getZoneName();
                    Object other$zoneName = other.getZoneName();
                    if (this$zoneName == null) {
                        if (other$zoneName == null) {
                            break label487;
                        }
                    } else if (this$zoneName.equals(other$zoneName)) {
                        break label487;
                    }

                    return false;
                }

                Object this$resourceId = this.getResourceId();
                Object other$resourceId = other.getResourceId();
                if (this$resourceId == null) {
                    if (other$resourceId != null) {
                        return false;
                    }
                } else if (!this$resourceId.equals(other$resourceId)) {
                    return false;
                }

                label473: {
                    Object this$regionId = this.getRegionId();
                    Object other$regionId = other.getRegionId();
                    if (this$regionId == null) {
                        if (other$regionId == null) {
                            break label473;
                        }
                    } else if (this$regionId.equals(other$regionId)) {
                        break label473;
                    }

                    return false;
                }

                label466: {
                    Object this$resourceName = this.getResourceName();
                    Object other$resourceName = other.getResourceName();
                    if (this$resourceName == null) {
                        if (other$resourceName == null) {
                            break label466;
                        }
                    } else if (this$resourceName.equals(other$resourceName)) {
                        break label466;
                    }

                    return false;
                }

                Object this$actionTypeName = this.getActionTypeName();
                Object other$actionTypeName = other.getActionTypeName();
                if (this$actionTypeName == null) {
                    if (other$actionTypeName != null) {
                        return false;
                    }
                } else if (!this$actionTypeName.equals(other$actionTypeName)) {
                    return false;
                }

                Object this$orderSn = this.getOrderSn();
                Object other$orderSn = other.getOrderSn();
                if (this$orderSn == null) {
                    if (other$orderSn != null) {
                        return false;
                    }
                } else if (!this$orderSn.equals(other$orderSn)) {
                    return false;
                }

                label445: {
                    Object this$payTime = this.getPayTime();
                    Object other$payTime = other.getPayTime();
                    if (this$payTime == null) {
                        if (other$payTime == null) {
                            break label445;
                        }
                    } else if (this$payTime.equals(other$payTime)) {
                        break label445;
                    }

                    return false;
                }

                label438: {
                    Object this$feeBeginTime = this.getFeeBeginTime();
                    Object other$feeBeginTime = other.getFeeBeginTime();
                    if (this$feeBeginTime == null) {
                        if (other$feeBeginTime == null) {
                            break label438;
                        }
                    } else if (this$feeBeginTime.equals(other$feeBeginTime)) {
                        break label438;
                    }

                    return false;
                }

                Object this$feeEndTime = this.getFeeEndTime();
                Object other$feeEndTime = other.getFeeEndTime();
                if (this$feeEndTime == null) {
                    if (other$feeEndTime != null) {
                        return false;
                    }
                } else if (!this$feeEndTime.equals(other$feeEndTime)) {
                    return false;
                }

                label424: {
                    Object this$configDesc = this.getConfigDesc();
                    Object other$configDesc = other.getConfigDesc();
                    if (this$configDesc == null) {
                        if (other$configDesc == null) {
                            break label424;
                        }
                    } else if (this$configDesc.equals(other$configDesc)) {
                        break label424;
                    }

                    return false;
                }

                Object this$totalCost = this.getTotalCost();
                Object other$totalCost = other.getTotalCost();
                if (this$totalCost == null) {
                    if (other$totalCost != null) {
                        return false;
                    }
                } else if (!this$totalCost.equals(other$totalCost)) {
                    return false;
                }

                label410: {
                    Object this$reduceType = this.getReduceType();
                    Object other$reduceType = other.getReduceType();
                    if (this$reduceType == null) {
                        if (other$reduceType == null) {
                            break label410;
                        }
                    } else if (this$reduceType.equals(other$reduceType)) {
                        break label410;
                    }

                    return false;
                }

                Object this$money = this.getMoney();
                Object other$money = other.getMoney();
                if (this$money == null) {
                    if (other$money != null) {
                        return false;
                    }
                } else if (!this$money.equals(other$money)) {
                    return false;
                }

                Object this$status = this.getStatus();
                Object other$status = other.getStatus();
                if (this$status == null) {
                    if (other$status != null) {
                        return false;
                    }
                } else if (!this$status.equals(other$status)) {
                    return false;
                }

                Object this$productDetail = this.getProductDetail();
                Object other$productDetail = other.getProductDetail();
                if (this$productDetail == null) {
                    if (other$productDetail != null) {
                        return false;
                    }
                } else if (!this$productDetail.equals(other$productDetail)) {
                    return false;
                }

                label382: {
                    Object this$productCode = this.getProductCode();
                    Object other$productCode = other.getProductCode();
                    if (this$productCode == null) {
                        if (other$productCode == null) {
                            break label382;
                        }
                    } else if (this$productCode.equals(other$productCode)) {
                        break label382;
                    }

                    return false;
                }

                label375: {
                    Object this$subscriptionType = this.getSubscriptionType();
                    Object other$subscriptionType = other.getSubscriptionType();
                    if (this$subscriptionType == null) {
                        if (other$subscriptionType == null) {
                            break label375;
                        }
                    } else if (this$subscriptionType.equals(other$subscriptionType)) {
                        break label375;
                    }

                    return false;
                }

                Object this$deductedByCashCoupons = this.getDeductedByCashCoupons();
                Object other$deductedByCashCoupons = other.getDeductedByCashCoupons();
                if (this$deductedByCashCoupons == null) {
                    if (other$deductedByCashCoupons != null) {
                        return false;
                    }
                } else if (!this$deductedByCashCoupons.equals(other$deductedByCashCoupons)) {
                    return false;
                }

                label361: {
                    Object this$deductedByCoupons = this.getDeductedByCoupons();
                    Object other$deductedByCoupons = other.getDeductedByCoupons();
                    if (this$deductedByCoupons == null) {
                        if (other$deductedByCoupons == null) {
                            break label361;
                        }
                    } else if (this$deductedByCoupons.equals(other$deductedByCoupons)) {
                        break label361;
                    }

                    return false;
                }

                label354: {
                    Object this$deductedByPrepaidCard = this.getDeductedByPrepaidCard();
                    Object other$deductedByPrepaidCard = other.getDeductedByPrepaidCard();
                    if (this$deductedByPrepaidCard == null) {
                        if (other$deductedByPrepaidCard == null) {
                            break label354;
                        }
                    } else if (this$deductedByPrepaidCard.equals(other$deductedByPrepaidCard)) {
                        break label354;
                    }

                    return false;
                }

                Object this$invoiceDiscount = this.getInvoiceDiscount();
                Object other$invoiceDiscount = other.getInvoiceDiscount();
                if (this$invoiceDiscount == null) {
                    if (other$invoiceDiscount != null) {
                        return false;
                    }
                } else if (!this$invoiceDiscount.equals(other$invoiceDiscount)) {
                    return false;
                }

                Object this$outstandingAmount = this.getOutstandingAmount();
                Object other$outstandingAmount = other.getOutstandingAmount();
                if (this$outstandingAmount == null) {
                    if (other$outstandingAmount != null) {
                        return false;
                    }
                } else if (!this$outstandingAmount.equals(other$outstandingAmount)) {
                    return false;
                }

                label333: {
                    Object this$pretaxAmount = this.getPretaxAmount();
                    Object other$pretaxAmount = other.getPretaxAmount();
                    if (this$pretaxAmount == null) {
                        if (other$pretaxAmount == null) {
                            break label333;
                        }
                    } else if (this$pretaxAmount.equals(other$pretaxAmount)) {
                        break label333;
                    }

                    return false;
                }

                label326: {
                    Object this$pretaxGrossAmount = this.getPretaxGrossAmount();
                    Object other$pretaxGrossAmount = other.getPretaxGrossAmount();
                    if (this$pretaxGrossAmount == null) {
                        if (other$pretaxGrossAmount == null) {
                            break label326;
                        }
                    } else if (this$pretaxGrossAmount.equals(other$pretaxGrossAmount)) {
                        break label326;
                    }

                    return false;
                }

                Object this$roundDownDiscount = this.getRoundDownDiscount();
                Object other$roundDownDiscount = other.getRoundDownDiscount();
                if (this$roundDownDiscount == null) {
                    if (other$roundDownDiscount != null) {
                        return false;
                    }
                } else if (!this$roundDownDiscount.equals(other$roundDownDiscount)) {
                    return false;
                }

                label312: {
                    Object this$subscriptionId = this.getSubscriptionId();
                    Object other$subscriptionId = other.getSubscriptionId();
                    if (this$subscriptionId == null) {
                        if (other$subscriptionId == null) {
                            break label312;
                        }
                    } else if (this$subscriptionId.equals(other$subscriptionId)) {
                        break label312;
                    }

                    return false;
                }

                Object this$subscriptionName = this.getSubscriptionName();
                Object other$subscriptionName = other.getSubscriptionName();
                if (this$subscriptionName == null) {
                    if (other$subscriptionName != null) {
                        return false;
                    }
                } else if (!this$subscriptionName.equals(other$subscriptionName)) {
                    return false;
                }

                label298: {
                    Object this$resourceGroupName = this.getResourceGroupName();
                    Object other$resourceGroupName = other.getResourceGroupName();
                    if (this$resourceGroupName == null) {
                        if (other$resourceGroupName == null) {
                            break label298;
                        }
                    } else if (this$resourceGroupName.equals(other$resourceGroupName)) {
                        break label298;
                    }

                    return false;
                }

                Object this$quantity = this.getQuantity();
                Object other$quantity = other.getQuantity();
                if (this$quantity == null) {
                    if (other$quantity != null) {
                        return false;
                    }
                } else if (!this$quantity.equals(other$quantity)) {
                    return false;
                }

                Object this$orderSnName = this.getOrderSnName();
                Object other$orderSnName = other.getOrderSnName();
                if (this$orderSnName == null) {
                    if (other$orderSnName != null) {
                        return false;
                    }
                } else if (!this$orderSnName.equals(other$orderSnName)) {
                    return false;
                }

                Object this$unitPrice = this.getUnitPrice();
                Object other$unitPrice = other.getUnitPrice();
                if (this$unitPrice == null) {
                    if (other$unitPrice != null) {
                        return false;
                    }
                } else if (!this$unitPrice.equals(other$unitPrice)) {
                    return false;
                }

                label270: {
                    Object this$billingCurrency = this.getBillingCurrency();
                    Object other$billingCurrency = other.getBillingCurrency();
                    if (this$billingCurrency == null) {
                        if (other$billingCurrency == null) {
                            break label270;
                        }
                    } else if (this$billingCurrency.equals(other$billingCurrency)) {
                        break label270;
                    }

                    return false;
                }

                label263: {
                    Object this$consumedService = this.getConsumedService();
                    Object other$consumedService = other.getConsumedService();
                    if (this$consumedService == null) {
                        if (other$consumedService == null) {
                            break label263;
                        }
                    } else if (this$consumedService.equals(other$consumedService)) {
                        break label263;
                    }

                    return false;
                }

                Object this$meterId = this.getMeterId();
                Object other$meterId = other.getMeterId();
                if (this$meterId == null) {
                    if (other$meterId != null) {
                        return false;
                    }
                } else if (!this$meterId.equals(other$meterId)) {
                    return false;
                }

                label249: {
                    Object this$useResourceData = this.getUseResourceData();
                    Object other$useResourceData = other.getUseResourceData();
                    if (this$useResourceData == null) {
                        if (other$useResourceData == null) {
                            break label249;
                        }
                    } else if (this$useResourceData.equals(other$useResourceData)) {
                        break label249;
                    }

                    return false;
                }

                label242: {
                    Object this$month = this.getMonth();
                    Object other$month = other.getMonth();
                    if (this$month == null) {
                        if (other$month == null) {
                            break label242;
                        }
                    } else if (this$month.equals(other$month)) {
                        break label242;
                    }

                    return false;
                }

                Object this$productLine = this.getProductLine();
                Object other$productLine = other.getProductLine();
                if (this$productLine == null) {
                    if (other$productLine != null) {
                        return false;
                    }
                } else if (!this$productLine.equals(other$productLine)) {
                    return false;
                }

                return true;
            }
        }
    }

    protected boolean canEqual(Object other) {
        return other instanceof PublicCloudBillModel;
    }

    @Override
    public int hashCode() {
        int result = 1;
        Object $businessCodeName = this.getBusinessCodeName();
        result = result * 59 + ($businessCodeName == null ? 43 : $businessCodeName.hashCode());
        Object $productName = this.getProductName();
        result = result * 59 + ($productName == null ? 43 : $productName.hashCode());
        Object $payModeName = this.getPayModeName();
        result = result * 59 + ($payModeName == null ? 43 : $payModeName.hashCode());
        Object $regionName = this.getRegionName();
        result = result * 59 + ($regionName == null ? 43 : $regionName.hashCode());
        Object $zoneName = this.getZoneName();
        result = result * 59 + ($zoneName == null ? 43 : $zoneName.hashCode());
        Object $resourceId = this.getResourceId();
        result = result * 59 + ($resourceId == null ? 43 : $resourceId.hashCode());
        Object $regionId = this.getRegionId();
        result = result * 59 + ($regionId == null ? 43 : $regionId.hashCode());
        Object $resourceName = this.getResourceName();
        result = result * 59 + ($resourceName == null ? 43 : $resourceName.hashCode());
        Object $actionTypeName = this.getActionTypeName();
        result = result * 59 + ($actionTypeName == null ? 43 : $actionTypeName.hashCode());
        Object $orderSn = this.getOrderSn();
        result = result * 59 + ($orderSn == null ? 43 : $orderSn.hashCode());
        Object $payTime = this.getPayTime();
        result = result * 59 + ($payTime == null ? 43 : $payTime.hashCode());
        Object $feeBeginTime = this.getFeeBeginTime();
        result = result * 59 + ($feeBeginTime == null ? 43 : $feeBeginTime.hashCode());
        Object $feeEndTime = this.getFeeEndTime();
        result = result * 59 + ($feeEndTime == null ? 43 : $feeEndTime.hashCode());
        Object $configDesc = this.getConfigDesc();
        result = result * 59 + ($configDesc == null ? 43 : $configDesc.hashCode());
        Object $totalCost = this.getTotalCost();
        result = result * 59 + ($totalCost == null ? 43 : $totalCost.hashCode());
        Object $reduceType = this.getReduceType();
        result = result * 59 + ($reduceType == null ? 43 : $reduceType.hashCode());
        Object $money = this.getMoney();
        result = result * 59 + ($money == null ? 43 : $money.hashCode());
        Object $status = this.getStatus();
        result = result * 59 + ($status == null ? 43 : $status.hashCode());
        Object $productDetail = this.getProductDetail();
        result = result * 59 + ($productDetail == null ? 43 : $productDetail.hashCode());
        Object $productCode = this.getProductCode();
        result = result * 59 + ($productCode == null ? 43 : $productCode.hashCode());
        Object $subscriptionType = this.getSubscriptionType();
        result = result * 59 + ($subscriptionType == null ? 43 : $subscriptionType.hashCode());
        Object $deductedByCashCoupons = this.getDeductedByCashCoupons();
        result = result * 59 + ($deductedByCashCoupons == null ? 43 : $deductedByCashCoupons.hashCode());
        Object $deductedByCoupons = this.getDeductedByCoupons();
        result = result * 59 + ($deductedByCoupons == null ? 43 : $deductedByCoupons.hashCode());
        Object $deductedByPrepaidCard = this.getDeductedByPrepaidCard();
        result = result * 59 + ($deductedByPrepaidCard == null ? 43 : $deductedByPrepaidCard.hashCode());
        Object $invoiceDiscount = this.getInvoiceDiscount();
        result = result * 59 + ($invoiceDiscount == null ? 43 : $invoiceDiscount.hashCode());
        Object $outstandingAmount = this.getOutstandingAmount();
        result = result * 59 + ($outstandingAmount == null ? 43 : $outstandingAmount.hashCode());
        Object $pretaxAmount = this.getPretaxAmount();
        result = result * 59 + ($pretaxAmount == null ? 43 : $pretaxAmount.hashCode());
        Object $pretaxGrossAmount = this.getPretaxGrossAmount();
        result = result * 59 + ($pretaxGrossAmount == null ? 43 : $pretaxGrossAmount.hashCode());
        Object $roundDownDiscount = this.getRoundDownDiscount();
        result = result * 59 + ($roundDownDiscount == null ? 43 : $roundDownDiscount.hashCode());
        Object $subscriptionId = this.getSubscriptionId();
        result = result * 59 + ($subscriptionId == null ? 43 : $subscriptionId.hashCode());
        Object $subscriptionName = this.getSubscriptionName();
        result = result * 59 + ($subscriptionName == null ? 43 : $subscriptionName.hashCode());
        Object $resourceGroupName = this.getResourceGroupName();
        result = result * 59 + ($resourceGroupName == null ? 43 : $resourceGroupName.hashCode());
        Object $quantity = this.getQuantity();
        result = result * 59 + ($quantity == null ? 43 : $quantity.hashCode());
        Object $orderSnName = this.getOrderSnName();
        result = result * 59 + ($orderSnName == null ? 43 : $orderSnName.hashCode());
        Object $unitPrice = this.getUnitPrice();
        result = result * 59 + ($unitPrice == null ? 43 : $unitPrice.hashCode());
        Object $billingCurrency = this.getBillingCurrency();
        result = result * 59 + ($billingCurrency == null ? 43 : $billingCurrency.hashCode());
        Object $consumedService = this.getConsumedService();
        result = result * 59 + ($consumedService == null ? 43 : $consumedService.hashCode());
        Object $meterId = this.getMeterId();
        result = result * 59 + ($meterId == null ? 43 : $meterId.hashCode());
        Object $useResourceData = this.getUseResourceData();
        result = result * 59 + ($useResourceData == null ? 43 : $useResourceData.hashCode());
        Object $month = this.getMonth();
        result = result * 59 + ($month == null ? 43 : $month.hashCode());
        Object $productLine = this.getProductLine();
        result = result * 59 + ($productLine == null ? 43 : $productLine.hashCode());
        return result;
    }

    @Override
    public String toString() {
        return "PublicCloudBillModel(businessCodeName=" + this.getBusinessCodeName() + ", productName=" + this.getProductName() + ", payModeName=" + this.getPayModeName() + ", regionName=" + this.getRegionName() + ", zoneName=" + this.getZoneName() + ", resourceId=" + this.getResourceId() + ", regionId=" + this.getRegionId() + ", resourceName=" + this.getResourceName() + ", actionTypeName=" + this.getActionTypeName() + ", orderSn=" + this.getOrderSn() + ", payTime=" + this.getPayTime() + ", feeBeginTime=" + this.getFeeBeginTime() + ", feeEndTime=" + this.getFeeEndTime() + ", configDesc=" + this.getConfigDesc() + ", totalCost=" + this.getTotalCost() + ", reduceType=" + this.getReduceType() + ", money=" + this.getMoney() + ", status=" + this.getStatus() + ", productDetail=" + this.getProductDetail() + ", productCode=" + this.getProductCode() + ", subscriptionType=" + this.getSubscriptionType() + ", deductedByCashCoupons=" + this.getDeductedByCashCoupons() + ", deductedByCoupons=" + this.getDeductedByCoupons() + ", deductedByPrepaidCard=" + this.getDeductedByPrepaidCard() + ", invoiceDiscount=" + this.getInvoiceDiscount() + ", outstandingAmount=" + this.getOutstandingAmount() + ", pretaxAmount=" + this.getPretaxAmount() + ", pretaxGrossAmount=" + this.getPretaxGrossAmount() + ", roundDownDiscount=" + this.getRoundDownDiscount() + ", subscriptionId=" + this.getSubscriptionId() + ", subscriptionName=" + this.getSubscriptionName() + ", resourceGroupName=" + this.getResourceGroupName() + ", quantity=" + this.getQuantity() + ", orderSnName=" + this.getOrderSnName() + ", unitPrice=" + this.getUnitPrice() + ", billingCurrency=" + this.getBillingCurrency() + ", consumedService=" + this.getConsumedService() + ", meterId=" + this.getMeterId() + ", useResourceData=" + this.getUseResourceData() + ", month=" + this.getMonth() + ", productLine=" + this.getProductLine() + ")";
    }

    @Data
    public static class MeterDetailsModel {
        private String meterName;
        private String meterCategory;
        private String meterSubCategory;
        private String unitOfMeasure;

        public MeterDetailsModel() {
        }

        @Override
        public boolean equals(Object o) {
            if (o == this) {
                return true;
            } else if (!(o instanceof PublicCloudBillModel.MeterDetailsModel)) {
                return false;
            } else {
                PublicCloudBillModel.MeterDetailsModel other = (PublicCloudBillModel.MeterDetailsModel)o;
                if (!other.canEqual(this)) {
                    return false;
                } else {
                    label59: {
                        Object this$meterName = this.getMeterName();
                        Object other$meterName = other.getMeterName();
                        if (this$meterName == null) {
                            if (other$meterName == null) {
                                break label59;
                            }
                        } else if (this$meterName.equals(other$meterName)) {
                            break label59;
                        }

                        return false;
                    }

                    Object this$meterCategory = this.getMeterCategory();
                    Object other$meterCategory = other.getMeterCategory();
                    if (this$meterCategory == null) {
                        if (other$meterCategory != null) {
                            return false;
                        }
                    } else if (!this$meterCategory.equals(other$meterCategory)) {
                        return false;
                    }

                    Object this$meterSubCategory = this.getMeterSubCategory();
                    Object other$meterSubCategory = other.getMeterSubCategory();
                    if (this$meterSubCategory == null) {
                        if (other$meterSubCategory != null) {
                            return false;
                        }
                    } else if (!this$meterSubCategory.equals(other$meterSubCategory)) {
                        return false;
                    }

                    Object this$unitOfMeasure = this.getUnitOfMeasure();
                    Object other$unitOfMeasure = other.getUnitOfMeasure();
                    if (this$unitOfMeasure == null) {
                        if (other$unitOfMeasure != null) {
                            return false;
                        }
                    } else if (!this$unitOfMeasure.equals(other$unitOfMeasure)) {
                        return false;
                    }

                    return true;
                }
            }
        }

        protected boolean canEqual(Object other) {
            return other instanceof PublicCloudBillModel.MeterDetailsModel;
        }

        @Override
        public int hashCode() {
            int resultx = 1;
            Object $meterName = this.getMeterName();
            int result = resultx * 59 + ($meterName == null ? 43 : $meterName.hashCode());
            Object $meterCategory = this.getMeterCategory();
            result = result * 59 + ($meterCategory == null ? 43 : $meterCategory.hashCode());
            Object $meterSubCategory = this.getMeterSubCategory();
            result = result * 59 + ($meterSubCategory == null ? 43 : $meterSubCategory.hashCode());
            Object $unitOfMeasure = this.getUnitOfMeasure();
            result = result * 59 + ($unitOfMeasure == null ? 43 : $unitOfMeasure.hashCode());
            return result;
        }

        @Override
        public String toString() {
            return "PublicCloudBillModel.MeterDetailsModel(meterName=" + this.getMeterName() + ", meterCategory=" + this.getMeterCategory() + ", meterSubCategory=" + this.getMeterSubCategory() + ", unitOfMeasure=" + this.getUnitOfMeasure() + ")";
        }
    }
}
