package com.bocloud.cos.params;

import com.bocloud.cos.utils.JsonToStringDeserializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 克隆请求参数
 *
 * @author tyl
 * @since 2021/4/10 14:45
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class CloneParams {
    private Long templateId;
    /**
     * 平台ID
     */
    private Long vendorId;
    private String instance;
    private String instanceName;
    private String ipPolicy;
    private String name;
    private Long ipPoolId;
    private Long portGroupId;
    private Boolean isAddShterm;
    private List<String> addresses;
    /**
     * 用于前端回显实例数据
     */
    @JsonDeserialize(using = JsonToStringDeserializer.class)
    private String preview;
    /**
     * 资源池id
     */
    private Long poolGroupId;
}
