package com.bocloud.cos.repository;

import com.megatron.common.exception.DataBaseException;
import com.megatron.common.utils.MapTools;
import com.bocloud.cos.entity.ChargeItem;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @author tyl
 * @since 2021/5/26 14:20
 */
@Repository
public class ChargeItemRepository extends BasicGenericDao<ChargeItem, Long> {
    public ChargeItemRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public ChargeItem query(String itemSn) throws DataBaseException {
        String sql = "select  *  from  charge_item where is_deleted = 0 and item_sn = :itemSn";
        Map<String, Object> params = MapTools.simpleMap("itemSn", itemSn);
        List<ChargeItem> chargeItems = this.list(ChargeItem.class, sql, params);
        return chargeItems.isEmpty() ? null : chargeItems.get(0);
    }

    public void removeItem(String itemSn) throws DataBaseException {
        String sql = "update  charge_item set is_deleted = 1   where  item_sn = :itemSn";
        Map<String, Object> params = MapTools.simpleMap("itemSn", itemSn);
        this.execute(sql, params);
    }

    public List<ChargeItem> listAllLoopCost() throws DataBaseException {
        String sql = "select  *  from  charge_item where is_deleted = 0 and type = 'loop' ";
        return this.list(ChargeItem.class, sql);
    }
}
