package com.bocloud.cos.repository;

import com.bocloud.cos.entity.BillItem;
import com.bocloud.cos.entity.CostCenter;
import com.bocloud.cos.entity.ServiceSku;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;

import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 服务操作业务实现
 *
 * @author YuFengYang
 * @version 1.0
 * @since 2022/12/30 14:31
 */
@Repository
public class CostCenterRepository  extends BasicGenericDao<CostCenter, Long> {

    public CostCenterRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public int count(List<Param> params) {
        String sql = "select count(a.id) from cost_center a where a.is_deleted = 0";
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        sql = getQueryBuilder().buildRaw(sql, params, null, "a");
        return this.countQuery(sql, paramMap).intValue();
    }

    public List<CostCenter> list(Pager pager) {
        String sql = "select * from cost_center a where a.is_deleted = 0";
        Map<String, Object> paramMap = getQueryBuilder().getParam(pager.getParams());
        sql = getQueryBuilder().buildRaw(sql, pager, "a");
        return this.list(CostCenter.class, sql, paramMap);
    }

    public CostCenter getByCode(String code) {
        String sql = "select * from cost_center a where a.code = :code and a.is_deleted = 0 ";
        Map<String, Object> params = MapTools.simpleMap("code", code);
        List<CostCenter> list = this.list(CostCenter.class, sql, params);
        return list.isEmpty() ? null : list.get(0);
    }

}
