package com.bocloud.cos.repository.assess;

import com.bocloud.cos.entity.assess.AssessTaskMetric;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * 任务考核指标详情DAO
 *
 * @author lym
 */
@Repository
public class AssessTaskMetricRepository extends BasicGenericDao<AssessTaskMetric, Long> {

    public AssessTaskMetricRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public List<AssessTaskMetric> listByTaskId(Long taskId) {
        String sql = "select * from assess_task_metric where task_id = " + taskId;
        return list(AssessTaskMetric.class, sql);
    }

    public void removeByMetricIds(List<Long> metricIds) {
        String sql = "delete from assess_task_metric where metric_id in (:metricIds)";
        Map<String, Object> params = MapTools.simpleMap("metricIds", metricIds);
        execute(sql, params);
    }

    public List<AssessTaskMetric> listDetailByTaskId(Long taskId, String metricName) {
        String sql = "select tm.*, m.name as metric_name,m.acquisition_mode, ar.rule_content, " +
                " ar.submission_item, ar.score_setting, ar.scoring_manner, ar.data_function " +
                " from assess_task_metric tm" +
                " left join assess_metric m on m.id = tm.metric_id" +
                " left join assess_rule ar on ar.id = tm.metric_rule_id" +
                " where tm.task_id = " + taskId;
        if (StringUtils.hasText(metricName)) {
            sql += " and m.name like '%" + metricName + "%'";
        }
        return list(AssessTaskMetric.class, sql);
    }
}
