package com.bocloud.cos.repository.assess;

import com.bocloud.cos.entity.assess.AssessTask;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 考核任务DAO
 *
 * @author lym
 */
@Repository
public class AssessTaskRepository extends BasicGenericDao<AssessTask, Long> {

    @Value("${spring.datasource.cmp:cmp}")
    private String cmpDb;

    public AssessTaskRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public void deleteById(Long id) {
        String sql = "delete from assess_task where id = " + id;
        execute(sql);
    }

    public List<AssessTask> list(int page, int rows, Map<String, String> sorter, List<Param> params) {
        String sql = "select a.*, ac.name as class_name, acs.name as conformity_standard, u.name as creator, " +
                " (select count(1) from assess_object where task_id = a.id) as obj_num, " +
                " (select count(1) from assess_task_metric where task_id = a.id) as metric_num " +
                " from assess_task a" +
                " left join assess_classify ac on a.classify_id = ac.id " +
                " left join " + cmpDb + ".users u on a.creator_id = u.id" +
                " left join assess_conformity_standard acs on a.conformity_standard_id = acs.id" +
                " where 1=1 ";
        sql = getQueryBuilder().buildRaw(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.list(AssessTask.class, sql, paramMap);
    }

    public AssessTask detail(Long taskId) {
        String sql = "select a.*, ac.name as class_name, acs.name as conformity_standard, u.name as creator, " +
                " (select count(1) from assess_object where task_id = a.id) as obj_num, " +
                " (select count(1) from assess_task_metric where task_id = a.id) as metric_num " +
                " from assess_task a" +
                " left join assess_classify ac on a.classify_id = ac.id " +
                " left join " + cmpDb + ".users u on a.creator_id = u.id" +
                " left join assess_conformity_standard acs on a.conformity_standard_id = acs.id" +
                " where a.id = " + taskId;
        List<AssessTask> list = this.list(AssessTask.class, sql);
        if (list.isEmpty()) {
            return null;
        }
        return list.get(0);
    }

    public int count(List<Param> params) {
        String sql = "select count(1) from assess_task a where 1=1 ";
        sql = getQueryBuilder().build(sql, params, null, "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.countQuery(sql, paramMap).intValue();
    }

    public void updateStatus(Long taskId, String status) {
        String sql = "update assess_task set status = '" + status + "', gmt_modify = now() where id = " + taskId;
        execute(sql);
    }

}
