package com.bocloud.cos.driver;


import com.megatron.common.model.GeneralResult;
import com.bocloud.cos.provider.BillingProvider;
import com.bocloud.cos.repository.ProviderRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class BillingDriver extends GenericDriver<BillingProvider> {

    @Autowired
    private ProviderRepository repository;

    public BillingDriver() {
    }

    public GeneralResult billDetailList(String vendor, String month, String region) {
        BillingProvider provider = this.getProvider(vendor, BillingProvider.class, this.repository, region);
        return this.before(provider).isFailed() ? new GeneralResult(false, "云平台认证失败！") : provider.billDetailList(month);
    }

    public GeneralResult billPeriods(String vendor) {
        BillingProvider provider = this.getProvider(vendor, BillingProvider.class, this.repository);
        return this.before(provider).isFailed() ? new GeneralResult(false, "云平台认证失败！") : provider.billPeriods();
    }

    public GeneralResult periodPrices(String vendor, String periodUuid) {
        BillingProvider provider = this.getProvider(vendor, BillingProvider.class, this.repository);
        return this.before(provider).isFailed() ? new GeneralResult(false, "云平台认证失败！") : provider.periodPrices(periodUuid);
    }

    public GeneralResult nextLinkPrices(String vendor, String nextLink) {
        BillingProvider provider = this.getProvider(vendor, BillingProvider.class, this.repository);
        return this.before(provider).isFailed() ? new GeneralResult(false, "云平台认证失败！") : provider.nextLinkPrices(nextLink);
    }

    public GeneralResult queryInstanceBill(String vendor, String month, String fileDownPath) {
        BillingProvider provider = this.getProvider(vendor, BillingProvider.class, this.repository);
        return this.before(provider).isFailed() ? new GeneralResult(false, "云平台认证失败！") : provider.queryInstanceBill(month, fileDownPath);
    }
}
