package com.bocloud.cos.intf;

import com.bocloud.cos.entity.CostCenter;
import com.megatron.common.model.*;

/**
 * 服务操作业务实现
 *
 * @author YuFengYang
 * @version 1.0
 * @since 2022/12/30 14:37
 */
public interface CostCenterService {

    /**
     * 列表
     * @param pager 分页参数
     * @return 成本中心列表
     */
    GeneralResult<GridBean<CostCenter>> list(Pager pager);

    /**
     * 获取详细
     * @param id id
     * @return 成本中心
     */
    GeneralResult<CostCenter> detail(Long id);

    /**
     * 创建
     * @param costCenter 成本中心
     * @param context 请求上下文
     * @return 是否创建成功
     */
    Result create(CostCenter costCenter, RequestContext context);

    /**
     * 修改
     * @param id id
     * @param costCenter 成本中心
     * @param context 上下文
     * @return 是否修改成功
     */
    Result modify(Long id, CostCenter costCenter, RequestContext context);

    /**
     * 删除
     * @param id 要删除的成本中心id
     * @param context 上下文
     * @return 是否删除成功
     */
    Result remove(Long id, RequestContext context);
}
