package com.bocloud.cos.intf;

import com.bocloud.cos.model.CancelationParam;
import com.megatron.common.model.RequestContext;
import com.megatron.common.model.Result;

/**
 * 服务退订
 *
 * @author zhangyf
 * @since 2022年03月14日
 */
public interface ResourceUnsubscribeService {

    /**
     * 服务退订
     *
     * @param params  退订参数
     * @param context 当前用户
     * @return 结果
     */
    Result process(CancelationParam params, RequestContext context);

    /**
     * 清空回收站
     *
     * @param context 当前用户
     * @return 结果
     */
    Result empty(RequestContext context);

    /**
     * 回收租户资源
     *
     * @param orderItemSn 订单项sn
     */
    void reclaim(String orderItemSn);

}
