package com.bocloud.cos.provider.common;

import com.aliyun.ecs20140526.models.DescribeRegionsRequest;
import com.aliyun.ecs20140526.models.DescribeRegionsResponse;
import com.aliyun.ecs20140526.models.DescribeRegionsResponseBody;
import com.bocloud.cos.annotations.Provider;
import com.bocloud.cos.model.Butler;
import com.bocloud.cos.model.RegionModel;
import com.bocloud.cos.provider.aliyun.AliyunProvider;
import com.bocloud.cos.provider.aliyun.RegionConvertor;
import com.bocloud.cos.provider.convertor.BeanConvertor;
import com.megatron.common.model.GeneralResult;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

@Slf4j
@Provider("bocloud.cmp.aliyun")
public class AliyunLocationProvider extends AliyunProvider implements LocationProvider {

    private BeanConvertor<RegionModel, DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion> regionConvertor = new RegionConvertor();

    public AliyunLocationProvider(Butler butler) {
        super(butler);
    }

    @Override
    public GeneralResult listRegions() {
        new GeneralResult(false, "查询失败");
        DescribeRegionsRequest request = new DescribeRegionsRequest();

        GeneralResult result;
        try {
            DescribeRegionsResponse response = this.getECSClient().describeRegions(request);
            List<DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion> regions = response.getBody().getRegions().getRegion();
            result = new GeneralResult(true, this.regionConvertor.convertList(regions), "查询区域成功！");
        } catch (Exception var5) {
            log.error("listRegions error:", var5);
            result = new GeneralResult(false, var5.getMessage());
        }

        return result;
    }
}
