package com.bocloud.cos.provider.convertor;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

public interface BeanConvertor<T, K> {
    default List<T> convertList(List<? extends K> models) {
        return (List) Optional.ofNullable(models).map((list) -> {
            return (List) list.stream().map(this::convertModel).collect(Collectors.toList());
        }).orElse(new ArrayList());
    }

    default T convertModel(K model) {
        return null;
    }
}