package com.bocloud.cos.provider.convertor;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

public interface BeanJsonConvertor<T> {

    default T convertModel(JSONObject object) {
        return null;
    }

    default List<T> convertList(JSONArray array) {
        return (List) Optional.ofNullable(array).map((list) -> {
            return (List) list.stream().map(JSON::toJSONString).map(JSON::parseObject).map(this::convertModel).collect(Collectors.toList());
        }).orElse(new ArrayList());
    }
}
