package com.bocloud.cos.service.assess;

import com.bocloud.cos.entity.assess.AssessClassify;
import com.bocloud.cos.repository.assess.AssessClassifyRepository;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * @author wpj
 * @since 2023/10/30
 */
@Slf4j
@Service
public class AssessClassifyService {

    @Autowired
    AssessClassifyRepository assessClassifyRepository;

    public GridBean<AssessClassify> list(Pager pager, RequestContext context) {
        pager.setSorter(pager.getSorter() != null ? pager.getSorter() : new HashMap<>(2));
        pager.setParams(pager.getParams() != null ? pager.getParams() : new ArrayList<>());
        int total = assessClassifyRepository.count(pager.getParams());
        List<AssessClassify> list = assessClassifyRepository.list(pager.getPage(), pager.getRows(), pager.getSorter(), pager.getParams());
        return new GridBean<>(pager.getPage(), pager.getRows(), total, list);
    }

    public void save(AssessClassify assessClassify, RequestContext context) {
        saveOf(assessClassify, context);
        assessClassifyRepository.save(assessClassify);
    }

    public void update(AssessClassify assessClassify, RequestContext context) {
        AssessClassify ac = assessClassifyRepository.get(AssessClassify.class, assessClassify.getId());
        ac.setName(assessClassify.getName());
        ac.setRemark(assessClassify.getRemark());
        updateOf(ac, context);
        assessClassifyRepository.update(ac);
    }

    public void remove(Long id) {
        assessClassifyRepository.deleteById(id);
    }

    private void saveOf(AssessClassify assessClassify, RequestContext context) {
        assessClassify.setCreatorId(context.getTarget());
        assessClassify.setGmtCreate(new Date());
    }

    private void updateOf(AssessClassify assessClassify, RequestContext context) {
        assessClassify.setMenderId(context.getTarget());
        assessClassify.setGmtModify(new Date());
    }
}
